using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Runtime.InteropServices;/* UC245.dllをコールするのに必要 */

/* 注：アクティブプラットフォームのデフォルトはx64(64ビット)であるため
       32ビットOSの環境でデバッグ動作しようとするとエラー表示する可能性があります。
       その場合、構成マネージャーにてx86(32ビット)に切替えてデバッグ動作してください。*/

namespace SampleCSharp
{
    public partial class Form1 : Form
    {
		[DllImport("UC245A.dll")]
		static extern uint ucCAN_ListDevices();
		[DllImport("UC245A.dll")]
		static extern uint ucCAN_Open();		
		[DllImport("UC245A.dll")]
		static extern uint ucCAN_Init(uint baudraute, byte extendmode);
		[DllImport("UC245A.dll")]
		static extern uint ucCAN_Reset();		
		[DllImport("UC245A.dll")]
		static extern uint ucCAN_Send(uint id, byte dlc, [MarshalAs(UnmanagedType.LPArray)] byte[] p_data,byte opt);
		[DllImport("UC245A.dll")]
		static extern uint ucCAN_Recv(ref uint id, ref byte dlc, [MarshalAs(UnmanagedType.LPArray)] byte[] p_data, ref ulong time);
		[DllImport("UC245A.dll")]
		static extern uint ucCAN_Recv_Status();
		[DllImport("UC245A.dll")]
		static extern uint ucCAN_Close();

		ulong time_old = 0;
		ulong time_delta = 0;

        public Form1()
        {
            InitializeComponent();
        }
		private void Form1_Load(object sender, System.EventArgs e)
		{
			uint ret;
	
			/* デバイスのチェック */
			if(1 != ucCAN_ListDevices())
			{
				MessageBox.Show ("デバイスがありません");
				this.Close();
			}
			/* UC245をオープン */
			ret = ucCAN_Open();
			if(ret != 0)
			{
				MessageBox.Show ("オープンできません");
				this.Close();
			}
			/* 500kbps,標準IDで初期化 */
			ucCAN_Init(500000,0);
			/* 受信バッファをクリア */
			ucCAN_Reset();
			timer1.Enabled = true;
		}

		private void Form1_Closed(object sender, System.EventArgs e)
		{
			/* UC245をクローズ */
			ucCAN_Close();
		}

		private void timer1_Tick(object sender, System.EventArgs e)
		{
			uint ret;
			uint rid=0;
			byte rdlc=0;
			byte[] rdata=new Byte[8];
			ulong time_now = 0;

			string msg;
			/* CANデータ受信 */
			ret = ucCAN_Recv(ref rid,ref rdlc,rdata,ref time_now);
			/* 0だったら受信あり */
			if(ret == 0)
			{
				time_delta = time_now - time_old;
				
				msg = String.Format("{0:X3} {1:D2} {2:X2} {3:X2} {4:X2} {5:X2} {6:X2} {7:X2} {8:X2} {9:X2} {10:D9}.{11:D2} {12:D9}.{13:D2}",
				rid,rdlc,rdata[0],rdata[1],rdata[2],rdata[3],rdata[4],rdata[5],rdata[6],rdata[7],
				time_delta / 100,
				time_delta % 100,
				time_now / 100,
				time_now % 100);
				time_old = time_now;
				
				listBox1.Items.Add(msg);
				if (listBox1.Items.Count > 40) listBox1.Items.RemoveAt(0);
				if (listBox1.Items.Count > 8) listBox1.TopIndex = listBox1.Items.Count - 8;
				
			}
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			uint wid=0;
			byte wdlc=0;
			byte[] wdata=new Byte[8];

			wdlc = 8;

			for(byte i=0;i<wdlc;i++)
			{
				wdata[i]=i;
			}

			/* CANデータ送信 */
			ucCAN_Send(wid,wdlc,wdata,0);
		}
	}
}
